<?php
/**************************************************
  Coppermine 1.5.x Plugin - slider2
  *************************************************
  Copyright (c) 2009 Timos-Welt (www.timos-welt.de)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ********************************************
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/branches/cpg1.5.x/plugins/slider2/codebase.php $
  $Revision: 6983 $
  $LastChangedBy: timoswelt $
  $Date: 2010-01-02 10:24:42 +0100 (Sa, 02. Jan 2010) $
  **************************************************/

  
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Add plugin_install action
$thisplugin->add_action('plugin_install','slider2_install');

// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','slider2_uninstall');

// Add search display action
$thisplugin->add_filter('plugin_block','slider2_mainpage');

// Add filter for page head
$thisplugin->add_filter('page_meta','slider2_head');

global $SLIDER2SET,$lang_plugin_slider2;
require ('./plugins/slider2/include/init.inc.php');
require ('./plugins/slider2/include/load_slider2set.php');



// include some stuff in page header
function slider2_head()
{        
global $template_header, $lang_plugin_slider2, $CONFIG, $CPG_PHP_SELF;
    
    $slider2_headcode = "
<!-- Start slider2 ".$lang_plugin_slider2['version']." Headcode -->";
    
    $slider2_headcode .= <<<EOS

<script type="text/javascript" src="plugins/slider2/slider2.js"></script>
<style type="text/css">
  .slider2img { cursor: pointer; }
</style>
<!-- End slider2 Headcode -->

EOS;

// only insert stuff if we're on album list page
 $slider2_pages_array = array('index.php');
 if (in_array($CPG_PHP_SELF, $slider2_pages_array) == TRUE)
 {
 	 $template_header = str_replace('{META}','{META}'.$slider2_headcode,$template_header);
 }

}


function slider2_mainpage()
{
 global $CONFIG,$lang_plugin_slider2,$FORBIDDEN_SET,$SLIDER2SET,$lang_meta_album_names,$META_ALBUM_SET, $CPG_PHP_SELF,$matches;
 
 // only insert stuff if we're on album list page
 
 
 $slider2_pages_array = array('index.php');
 
 if (in_array($CPG_PHP_SELF, $slider2_pages_array) == TRUE)
 {
        if($matches[1] != 'slider2') {
          return $matches;
        }
        $cpgslideplug2_align=$SLIDER2SET['slider2_align'];
        if ($SLIDER2SET['slider2_autowidth']) $cpgslideplug2_align="left";
        echo "<!-- Start slider2 PlugIn ".$lang_plugin_slider2['version']." Table-->\n";
        $slider2_icon = array( 'topn' => 'most_viewed', 'lastup' => 'last_uploads', 'toprated' => 'top_rated', 'random' => 'random');
        starttable("100%", cpg_fetch_icon($slider2_icon[$SLIDER2SET['slider2_album']],0,$lang_meta_album_names[$SLIDER2SET['slider2_album']]).$lang_meta_album_names[$SLIDER2SET['slider2_album']]);
?>
        <tr>
            <td align="<?php echo $cpgslideplug2_align;?>">
                <table border="0" <?php if ($SLIDER2SET['slider2_autowidth']) echo "width=\"100%\" ";?> id="slider2getwidth" cellspacing="0" cellpadding="0">
                   <tr>
                       <td align="left">
                           <script type="text/javascript">
                                var slideshowgap2=2;
                                var copyspeed2=<?php echo $SLIDER2SET['slider2_speed'];?>;
                                var realcopyspeed22=<?php echo $SLIDER2SET['slider2_speed'];?>;
                                var cpgslid_2brwsx,cpgslid_2brwsy,cpgslid_2oldbrwsx,cpgslid_2oldbrwsy;
<?php
  // maximum pics to show
  $slider2limit=$SLIDER2SET['slider2_numberofpics'];
  // request of your database
  $slider2_pics='';
  $slider2_pics2='';
  $slider2_pics3='';
  $slider2_FORBIDDEN_SET = "";
  //if ($FORBIDDEN_SET != "") $slider2_FORBIDDEN_SET = $FORBIDDEN_SET;
  if ($FORBIDDEN_SET != "") $slider2_FORBIDDEN_SET = "$FORBIDDEN_SET";

  // request string for meta album toprated
  if ($SLIDER2SET['slider2_album'] == "toprated") {
    $slider2_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE filename like '%.jpg' AND filename not like 'youtube_%' $slider2_FORBIDDEN_SET AND votes >= '{$CONFIG['min_votes_for_rating']}' $META_ALBUM_SET ORDER BY pic_rating DESC, votes DESC, pid DESC LIMIT $slider2limit";
  }
  // request string for meta album most viewed
  else if ($SLIDER2SET['slider2_album'] == "topn") {
    $slider2_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE filename like '%.jpg' AND filename not like 'youtube_%' $slider2_FORBIDDEN_SET AND hits > 0 $META_ALBUM_SET ORDER BY hits DESC, filename LIMIT $slider2limit";  
  }
  // request string for meta album last uploads
  else if ($SLIDER2SET['slider2_album'] == "lastup") {
    $slider2_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE filename like '%.jpg' AND filename not like 'youtube_%' $slider2_FORBIDDEN_SET $META_ALBUM_SET ORDER BY pid DESC LIMIT $slider2limit";  
  }
  // request string for meta album random pics
  else
  {
  $slider2_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE filename like '%.jpg' AND filename not like 'youtube_%' $slider2_FORBIDDEN_SET $META_ALBUM_SET ORDER BY RAND() LIMIT $slider2limit";
  }
  // For reading result
  $slider2_rowset = array();
  // Index of tab
  $i=0;
  // max height : will be 75px or 100px
  $max_height=0;
  // For each pic.....building javascript in php
  if ($SLIDER2SET['slider2_autowidth']) $slider2_minpics = 15;
  else $slider2_minpics = 10;
  // result of request
  $slider2_result = cpg_db_query($slider2_query);
  while($slider2_row = mysql_fetch_array($slider2_result)){
    if (!$SLIDER2SET['slider2_skipportrait'] || ($slider2_row['pwidth']>$slider2_row['pheight'])) {
      // reading pid of pic
      $slider2_key=$slider2_row['pid'];
      // reading height of pic
      $slider2_image_size = compute_img_size($slider2_row['pwidth'], $slider2_row['pheight'], $CONFIG['thumb_width']);
      // Calcul de la hauteur maxi de la zone droulante (par dfaut = 75px)
      if ($slider2_image_size['height'] > $max_height) {
        $max_height = $slider2_image_size['height'];
      }
    // path of pic
    $slider2_file=get_pic_url($slider2_row,'thumb');
    $slider2_imgfile=get_pic_url($slider2_row,$SLIDER2SET['slider2_pictype']);
    if ($slider2_imgfile == "images/thumbs/thumb_nopic.png") $slider2_imgfile=get_pic_url($slider2_row,'fullsize');
    $slider2_pictitle = $slider2_row['title'];
    // link of pic
    
    if ($SLIDER2SET['slider2_useenlarge'] == 1) {
       $slider2_lien="<img src=\"".$slider2_file."\" onclick=\"enlarge(this);\" longdesc=\"".$slider2_imgfile."\" border=\"0\" name=\"".$slider2_row['pid']."\" class=\"slider2img\" alt=\"".$slider2_pictitle."\" />";
       $slider2_lien2="<img src=\"".$slider2_file."\" onclick=\"enlarge(this);\" longdesc=\"".$slider2_imgfile."\" border=\"0\" name=\"".$slider2_row['pid']."\" class=\"slider2img\" alt=\"".$slider2_pictitle."\" />";
       $slider2_lien3="<img src=\"".$slider2_file."\" onclick=\"enlarge(this);\" longdesc=\"".$slider2_imgfile."\" border=\"0\" name=\"".$slider2_row['pid']."\" class=\"slider2img\" alt=\"".$slider2_pictitle."\" />";
      }
      else
      {
       $slider2_lien="<a href=\"displayimage.php?pid=$slider2_key\"><img src=\"".$slider2_file."\" border=\"0\" onclick=\"copyspeed2=0;\" alt=\"".$slider2_pictitle."\" /></a>";
       $slider2_lien2="<a href=\"displayimage.php?pid=$slider2_key\"><img src=\"".$slider2_file."\" border=\"0\" onclick=\"copyspeed2=0;\" alt=\"".$slider2_pictitle."\" /></a>";
       $slider2_lien3="<a href=\"displayimage.php?pid=$slider2_key\"><img src=\"".$slider2_file."\" border=\"0\" onclick=\"copyspeed2=0;\" alt=\"".$slider2_pictitle."\" /></a>";
      }
    // building javascript code
    $slider2_pics .= $slider2_lien."&nbsp;";
    $slider2_pics2 .= $slider2_lien2."&nbsp;";
    $slider2_pics3 .= $slider2_lien3."&nbsp;";
    $i=$i+1;
   }
  }
  // free memory
  mysql_free_result($slider2_result);


  if ($i > 0) 
  {
    while ($i < $slider2_minpics)
    {
      $i = $i * 2;
      $slider2_pics .= str_replace('id="slider2','id="slider21',$slider2_pics);
      $slider2_pics2 .= str_replace('id="slider2','id="slider21',$slider2_pics2);
      $slider2_pics3 .= str_replace('id="slider2','id="slider21',$slider2_pics3);
    }
  }
    
    
      
  //Max height of pics fixed
  $cpgslideplug2_slider2height = $max_height."px";

?>                                var actualwidth2='';
                                var cross_slide3;
                                var cross_slide32;
                                var slider2_autowidth;
                                <?php if ($SLIDER2SET['slider2_autowidth']) echo "var autowidth2=1;"; else echo "var autowidth2=0;";?>

                                slid_addLoad2(cpgslideplug2_fillup);
                           </script>
                                <span id="slider2_temp" style="visibility:visible;position:absolute;top:-100px;white-space:nowrap;left:-9000px;"><?php echo $slider2_pics;?></span>
                                <div id="slider2_autow1" style="position:relative<?php if (!$SLIDER2SET['slider2_autowidth']) { echo ';width:'.$SLIDER2SET['slider2_width']."px"; } ?>;height:<?php echo $cpgslideplug2_slider2height;?>;overflow:hidden;white-space:nowrap;">
                                      <div id="slider2_autow2" style="white-space:nowrap;position:absolute<?php if (!$SLIDER2SET['slider2_autowidth']) { echo ';width:'.$SLIDER2SET['slider2_width']."px"; } ?>;height:<?php echo $cpgslideplug2_slider2height;?>;<?php if ($SLIDER2SET['slider2_bgcolor']) echo "background-color:".$SLIDER2SET['slider2_bgcolor'].";";?>">
                                          <div id="slider2_test2" style="visibility:hidden;position:absolute;left:0px;top:0px;white-space:nowrap;"><?php echo $slider2_pics2;?></div>  
                                          <div id="slider2_test3" style="visibility:hidden;position:absolute;left:-2000px;top:0px;white-space:nowrap;"><?php echo $slider2_pics3;?></div>
                                      </div>
                                </div>
                            </td>
                       </tr>
               </table>                
          </td>
     </tr>
<?php
endtable();
echo "<!-- End slider2 PlugIn Table-->\n";
  }
}

// Install
function slider2_install()
{
                global $CONFIG, $thisplugin;
                require 'include/sql_parse.php';

                // create table
                $db_schema = $thisplugin->fullpath . '/schema.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');

                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
                
                // insert default values
                $db_schema = $thisplugin->fullpath . '/basic.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');
              
                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
           return true;
}


// Unnstall and drop settings table
function slider2_uninstall()
{
        global $CONFIG;
        cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}plugin_slider2");
        return true;
}
?>